#include "asm.h"
#include "coroutine.h"

	@------------------------------------------------
	@ void co_call(coroutine_t co);
	@------------------------------------------------
ARM_ENTRY(co_call)
	stmfd	sp!, {r4-r12,lr}
	ldr	r1, =sp_sp
	ldr	r3, [r1]
	stmea	r3!, {r0,sp}				@ cospޔ
	ldr	r2, [r0]				@ Wv
	str	r3, [r1]
	add	r1, r0, #8
	add	r0, r0, #4
	ldr	r0, [r0]				@  co->data Ă
	ldr	sp, [r1]
	ldmfd	sp!, {r4-r12,lr}
	bx	r2

	@------------------------------------------------
	@ void co_goto(void (*func)(void*));
	@------------------------------------------------
ARM_ENTRY(co_goto)
	mov	lr, r0

	ldr	r1, =sp_sp
	ldr	r3, [r1]
	ldmea	r3!, {r0,r2}				@ cosp𕜌
	str	r3, [r1]

	str	lr, [r0]				@ WvĂKv͖
							@ gdb  co Ƃ̂߂ɎcĂ

	add	sp, r0, #(12 + CO_STACK_SIZE)		@ X^bN߂
	b	1f					@ co_resume ɓ

	@------------------------------------------------
	@ void co_resume(void);
	@------------------------------------------------
ARM_ENTRY(co_resume)
	ldr	r1, =sp_sp
	ldr	r3, [r1]
	ldmea	r3!, {r0,r2}				@ cosp𕜌
	str	r3, [r1]
1:
	stmfd	sp!, {r4-r12,lr}

	add	r1, r0, #8
	str	sp, [r1]
	mov	sp, r2
	str	lr, [r0]

	ldmfd	sp!, {r4-r12,lr}
	mov	r0, #0
	bx	lr

	@------------------------------------------------
	@ void co_exit(void);
	@------------------------------------------------
THUMB_ENTRY(co_exit_thumb)
	ldr	r1, =co_exit
	bx	r1

ARM_ENTRY(co_exit)
	stmfd	sp!, {r4-r12,lr}

	ldr	r1, =sp_sp
	ldr	r4, =co_exit
	ldr	r3, [r1]
	ldmea	r3!, {r0,r2}				@ cosp𕜌
	str	r3, [r1]

	add	r1, r0, #8
	str	sp, [r1]
	mov	sp, r2
	str	r4, [r0]

	ldmfd	sp!, {r4-r12,lr}
	mov	r0, #1
	bx	lr

@ stack pointer for stack pointer
LOCAL_ENTRY(sp_sp)
	.word	sp_stack

@ stack for stack pointer (8ĩX^bNm)
LOCAL_ENTRY(sp_stack)
	.word	0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0
